<template>
  <div v-if="redirect">Thanks for using our service. You can close this window.</div>

  <div v-else>
    <header v-show="!generated"><h1>Email QRCode generator</h1></header>

    <form v-show="!generated" action="#" @submit.prevent="generate">
      <fieldset>
        <legend>Email properties</legend>
        <div>
          <label for="email">Email</label>
          <input type="email" id="email" v-model.trim="inputs.email" required />
        </div>
        <div>
          <label for="subject">Subject</label>
          <input type="text" id="subject" v-model.trim="inputs.subject" required />
        </div>
        <div>
          <label for="body">Body</label>
          <textarea id="body" v-model.trim="inputs.body" rows="5" />
        </div>
      </fieldset>

      <fieldset>
        <legend>QRcode properties</legend>
        <div>
          <label for="error-correction">Error correction</label>
          <select v-model="inputs.errorCorrectionLevel" name="error_correction" id="error-correction">
            <option value="L">L (~7%)</option>
            <option value="M">M (~15%)</option>
            <option value="Q">Q (~25%)</option>
            <option value="H">H (~30%)</option>
          </select>
        </div>
      </fieldset>

      <div v-if="error" class="error">{{ error }}</div>

      <div class="actions">
        <button type="submit">Generate</button>
      </div>

    </form>

    <div v-show="generated">
      <div class="canvas-wrapper">
        <canvas ref="qrcode" />
      </div>

      <div v-show="!hide" class="actions">
        <p class="notice">
          You can favorite this page for later use or
          <button type="button" @click="generated = false">make another</button>
        </p>

        <p>
          You prefer to do it in Inkscape ?
          <button type="button" @click="copy">{{ copyButtonLabel }}</button>
        </p>
        <button @click="hide = true">Hide this notice</button>
      </div>
    </div>
  </div>

  <footer v-show="!hide">
    Made by ExperimentsLabs for Émilien.
    &mdash; <code>v{{ version }}</code>
    &mdash; Opensource <a href="https://gitlab.com/experimentslabs/tools/mail-r-code">code on Gitlab</a>.
  </footer>
</template>

<script>
import QRCode from 'qrcode'
import { version } from '../package.json'

const copyButtonLabel = 'Copy the string!'

export default {
  name: 'App',
  data () {
    return {
      // Page state
      redirect: false,  // Only show a message when true
      error: null,      // QRCode generation error
      generated: false, // QRCode is generated
      hide: false,      // Hide the interface buttons
      copyButtonLabel,  // Changing label on the "copy" button
      version,

      // Form
      inputs: {
        email: '',
        subject: '',
        body: '',
//         email: 'sarthe@theshifters.org',
//         subject: `Je souhaite rejoindre le groupe Shifters Sarthe`,
//         body: `Nom :
// Prénom :
// Ville (optionnel) :
//
// Présentation courte :
//
// Déjà cotisant chez les Shifters ?
//
// Merci de m'intégrer à la liste de diffusion du groupe local !`,
        errorCorrectionLevel: 'M',
      },
    }
  },
  computed: {
    link () {
      if (this.inputs.email === '') return

      return `mailto:${this.inputs.email}?subject=${encodeURIComponent(this.inputs.subject)}&body=${encodeURIComponent(this.inputs.body)}`
    },
  },
  methods: {
    /**
     * Generates the QRCode and displays it on canvas.
     *
     * @param {boolean} updateURL - Whether to update the current page URL (for favorites)
     */
    generate (updateURL = true) {
      console.log('Generating code...')

      this.error = null
      QRCode.toCanvas(this.$refs.qrcode, this.makeRedirectLink(true), {
        errorCorrectionLevel: this.inputs.errorCorrectionLevel,
        width: 512,
      }, (error) => {
        if (error) {
          this.error = error
          return
        }

        if (updateURL) window.history.pushState({ ...this.inputs }, null, this.makeRedirectLink())
        this.generated = true
      })
    },

    /**
     * Creates a link to the page that displays the code OR makes a redirection
     *
     * @param {boolean} redirect - When true, user will be redirected to the "mailto:" URL instead of the QRcode being displayed.
     * @return {string} URL
     */
    makeRedirectLink (redirect = false) {
      const url = new URL(document.location.href)
      url.searchParams.set('email', this.inputs.email)
      url.searchParams.set('subject', this.inputs.subject)
      url.searchParams.set('body', this.inputs.body)
      if (redirect) url.searchParams.set('redirect', 'true')
      else url.searchParams.set('errorCorrectionLevel', this.inputs.errorCorrectionLevel)

      return url.toString()
    },

    /**
     * Copies the QRCode content to clipboard
     */
    copy () {
      navigator.clipboard.writeText(this.link)
          .then(() => {
            this.copyButtonLabel = 'copied !'
            setTimeout(() => { this.copyButtonLabel = copyButtonLabel }, 300)
          })
    },
  },

  created () {
    const url = new URL(document.location.href)
    const fields = Object.keys(this.inputs)
    fields.forEach((field) => {
      const value = url.searchParams.get(field)
      if (value) this.inputs[field] = value
    })

    this.redirect = url.searchParams.get('redirect')

    if (this.redirect) {
      window.location.href = this.link
    } else if (this.inputs.email.trim() !== '') {
      this.$nextTick(() => { this.generate(false) })
    }
  },
}
</script>

<style>
*,
*::before,
*::after {
  box-sizing: border-box;
  font-family: monospace;
}

html {
  font-size: 12px;
}

body {
  background-color: #111;
  color: #EEE;
}

#app {
  width: 512px;
  margin: 0 auto;
}

a,
a:visited {
  color: #F6BB42;
}

button {
  padding: 0.2em;
  line-height: 1em;
  border: 1px solid #666;
  color: currentColor;
  background-color: #444;
}

label {
  display: block;
}

input,
select,
textarea {
  width: 100%;
  display: block;
  color: #111;
}

fieldset {
  border-color: #333;
}

fieldset:not(:first-child) {
  margin-top: 2em;
}

legend {
  color: #888;
}

footer {
  border-top: 1px solid #ccc;
  font-size: 0.8em
}

.actions {
  text-align: right;
  padding: 1em 0;
}

.notice {
  color: #457AB8;
}

.error {
  border: 1px solid red;
  color: red;
  padding: 1em;
  margin: 1em 0;
}

.canvas-wrapper {
  padding: 5em 0;
  text-align: center;
}
</style>
